# Copyright 2016 Jochen Fabricius
# Distribution and modification is encouraged

macro avg {args} {
  set colors [list red purple darkblue yellow darkgreen brown black] 

  switch -- $args {
    all {
      set IDs [:list]
    }
    visible {
      set IDs [:list visible]
    }
    default {
      set IDs $args
    }
  }  
  # make a copy of the first curve
  :copy [lindex $IDs 0]
  set avg [:paste]
  # rename and hide
  :modify $avg Name "Average" Color black Show no

  # now make the square sum of all curves
  foreach id [lrange $IDs 1 end] {
    :expr $avg + $id
  }
  :expr $avg / [expr {sqrt([llength $IDs])}]
  # make visible
  :modify $avg Show yes

  # create lower and upper limits
  :copy [lindex $IDs 0]
  set lower [:paste]
  :modify $lower Name "Lower limit" Color black Show no
  set upper [:paste]
  :modify $upper Name "Upper limit" Color black Show no

  :clip upper {*}[concat $upper [lrange $IDs 1 end] { }]
  :clip lower {*}[concat $lower [lrange $IDs 1 end] { }]

  # make them visible
  :modify $upper Show yes
  :modify $lower Show yes
}

